import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:ibad/ibad.dart';
import 'package:flutter/services.dart';

void main() => runApp(MyApp());

late Map<String, dynamic> data = {};
late String message = "", referencenum = "", status = "";

final keycontroller = TextEditingController();
final amountcontroller = TextEditingController();
final referencenumbercontroller = TextEditingController();
final customeremailcontroller = TextEditingController();
final customernumbercontroller = TextEditingController();
final consumernamecontroller = TextEditingController();
final tokencontroller = TextEditingController();
final isgeneratedcontroller = TextEditingController();

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    SystemChrome.setPreferredOrientations([
      DeviceOrientation.portraitUp,
    ]);

    return MaterialApp(
      title: 'Welcome to Flutter',
      home: Scaffold(body: Checkout(title: "Checkout")),
    );
  }
}

class Checkout extends StatefulWidget {
  Checkout({required this.title});
  final String title;

  @override
  _CheckoutState createState() => _CheckoutState();
}

class _CheckoutState extends State<Checkout> {
  @override
  void initState() {
    super.initState();

    keycontroller.text = "3735cf8d-6f7c-44f9-93c8-a35aa0b09d97";
    referencenumbercontroller.text = "207";
    amountcontroller.text = "100";
    isgeneratedcontroller.text = "0";
    customeremailcontroller.text = "ibad@gmail.com";
    customernumbercontroller.text = "03132689474";
    consumernamecontroller.text = "Ibad Ahmed";
  }

  @override
  Widget build(BuildContext context) {
    final node = FocusScope.of(context);
    double Width = MediaQuery.of(context).size.width;

    return ListView(
      children: [
        Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Container(
              child: Column(
                children: [
                  Container(
                    margin: EdgeInsets.only(
                        left: 5.0, top: 25.0, right: 5.0, bottom: 5.0),
                    child: TextField(
                      // textInputAction: TextInputAction.next,
                      // onEditingComplete: () => node.nextFocus(),
                      controller: keycontroller,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        labelText: "Key",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                        EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: amountcontroller,
                      // textInputAction: TextInputAction.done,
                      // onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      keyboardType: TextInputType.number,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Amount",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                        EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: isgeneratedcontroller,
                      // textInputAction: TextInputAction.done,
                      // onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      keyboardType: TextInputType.number,
                      autocorrect: false,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Is generated",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                        EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: referencenumbercontroller,
                      // textInputAction: TextInputAction.done,
                      // onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      keyboardType: TextInputType.number,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Reference Number",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                        EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: customeremailcontroller,
                      // textInputAction: TextInputAction.done,
                      // onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      keyboardType: TextInputType.emailAddress,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Email",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                        EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: customernumbercontroller,
                      // textInputAction: TextInputAction.done,
                      // onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      keyboardType: TextInputType.number,
                      textInputAction: TextInputAction.next,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Phone",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                        EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: consumernamecontroller,
                      // textInputAction: TextInputAction.done,
                      // onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Name",
                      ),
                    ),
                  ),
                  Container(
                    margin:
                        EdgeInsets.symmetric(vertical: 5.0, horizontal: 5.0),
                    child: TextField(
                      controller: tokencontroller,
                      // textInputAction: TextInputAction.done,
                      // onEditingComplete: () => node.nextFocus(),
                      enableSuggestions: false,
                      autocorrect: false,
                      decoration: InputDecoration(
                        border: OutlineInputBorder(),
                        fillColor: Colors.white,
                        labelText: "Token",
                      ),
                    ),
                  ),
                  Container(
                    margin: EdgeInsets.all(25.0),
                    decoration: BoxDecoration(
                        borderRadius: BorderRadius.circular(5.0),
                        color: Colors.blue),
                    child: FlatButton(
                        onPressed: () {
                          if (int.parse(amountcontroller.text) > 1000000) {
                            return;
                          }
                          data = {
                            'key': keycontroller.text,
                            'amount': int.parse(amountcontroller.text)
                                .abs()
                                .toString(),
                            'is_generated':
                                int.parse(isgeneratedcontroller.text),
                            'reference_number': referencenumbercontroller.text,
                            'callback': 'callbackflutter',
                            'customer_email_address':
                                customeremailcontroller.text,
                            'customer_phone_number':
                                customernumbercontroller.text,
                            'token': tokencontroller.text,
                            'consumer_name': consumernamecontroller.text,
                          };

                          IbadCheckOut.initiateCheckOut(
                            data: data,
                            context: context,
                            callBack: (args) {
                              keycontroller.text = "";
                              amountcontroller.text = "";
                              referencenumbercontroller.text = "";
                              customeremailcontroller.text = "";
                              customernumbercontroller.text = "";
                              consumernamecontroller.text = "";
                              isgeneratedcontroller.text = "";
                              // print("Callback data $args");
                              String abc = args.toString();
                              //abc = abc.replaceAll( ',' , '\n' );
                              var jsondata = jsonDecode(abc);
                              var statusdata = jsondata['status'].toString();
                              var referencenumber =
                                  jsondata['reference_number'];
                              var messagedata = jsondata['message'];
                              print("status $statusdata");
                              setState(() {
                                status = statusdata;
                                referencenum = referencenumber;
                                message = messagedata;
                              });
                            },
                          );
                        },
                        child: Text("Pay Now")),
                  ),
                  Container(
                      width: Width,
                      margin:
                          EdgeInsets.symmetric(vertical: 5.0, horizontal: 10.0),
                      child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Text(
                            "Status: $status",
                            style: TextStyle(
                              fontSize: 18.0,
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                          Text(
                            "Ref No: $referencenum",
                            style: TextStyle(
                              fontSize: 18.0,
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                          Text(
                            "Message: $message",
                            style: TextStyle(
                              fontSize: 18.0,
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                        ],
                      ))
                ],
              ),
            )
          ],
        )
      ],
    );
  }
}
